#!/bin/bash                                                                     
                                                                                
##                                                                              
## Reloads Wireguard tunnel when a physical interface change happens            
## Intended for use with always active full tunnels                             
##                                                                              
## Also when using a second VPN, disables the WG tunnel when                    
## enabling the alternate and vice versa                                        
##                                                                              
                                                                                
# interface names as shown by 'ip a'                                            
WG_INTERFACE=''                                                   
ETH_INTERFACE=''                                                         
WIFI_INTERFACE=''                                                           
ALT_VPN=''                                                           
                                                                                
if [[ "$1" == "$ETH_INTERFACE" ]] || [[ "$1" == "$WIFI_INTERFACE" ]] && [[ "$2" == "up" ]]; then
    echo "running $0: $1 $2" | systemd-cat -t nm-dispatcher                     
    sleep 2                                                                     
    nmcli conn up $WG_INTERFACE                                                 
    resolvectl flush-caches                                                     
elif [[ "$1" == "$ALT_VPN" ]] && [[ "$2" == "up" ]]; then                       
    echo "running $0: $1 $2" | systemd-cat -t nm-dispatcher                     
    nmcli conn down $WG_INTERFACE                                               
elif [[ "$1" == "$ALT_VPN" ]] && [[ "$2" == "down" ]]; then                     
    echo "running $0: $1 $2" | systemd-cat -t nm-dispatcher                     
    nmcli conn up $WG_INTERFACE                                                 
fi                                                                              
                                                                                
exit 0